#include "ros/ros.h"
#include "../utilities/simulator_structures.h"
#include "clips_ros/SimuladorRepresentation.h"
#include "../motion_planner/motion_planner_utilities.h"
#include "action_planner.h"



int main(int argc ,char **argv)
{

    int j=0,k,num_actions;
    int test = 1;
    movement movements;
    char path[200];
    int flg_once=1;
    int count = 1;
    Actions plan;
    std::string ss;
    char exe_action[300];
    char string1[300];
    char string2[500];
    char ROS_System[300];
    char object[300];
    char answer[500];



    // ROS directives
    // Initializes Node Name
    ros::init(argc ,argv ,"simulator_action_planner_node");
    // Node handle declaration for communication with ROS system
    ros::NodeHandle n;
    //ros::Rate loop_rate(10);

    // It subscribes to the following topics: GUI, laser sensor, motion planner and manipulator
    // It subscribes to the GUI messages
    ros::Subscriber params_sub = n.subscribe("simulator_parameters_pub",0, parametersCallback);
    // It subscribes to the laser simulator messages
    ros::Subscriber sub = n.subscribe("/scan", 10, laserCallback);
    // It subscribes to the motion_planner messages
    ros::Subscriber params_mot = n.subscribe("motion_planner_msg", 100, msgCallbackMotionPlanner);
    // It subscribes to the manipulator messages
    //ros::Subscriber params_manipulator = n.subscribe("manipulator_msg", 100, msgCallbackManipulator);


    // Declare publisher, create publisher action_planner_msg 
    ros::Publisher action_planner_msg  = n.advertise<simulator::ActionPlanner>("action_planner_msg", 100);
    simulator::ActionPlanner msg;


    SimuladorRepresentation::setNodeHandle(&n);
    ros::Rate r(20);



   // it sets the environment's path
    strcpy(path,"./src/simulator/src/data/");
  



    printf("\n\n             ACTION PLANNER %d \n________________________________\n",j++);

    while( ros::ok()  )
    {


     while( params.run )
     {


     	ros::spinOnce();

	switch ( params.behavior) {

		 case 4:

                    	printf(" ******* SELECTION 4 %d *******\n",j++);
			break;

		 case 10:

			if(flg_once){
               			printf(" ******* SELECTION 10 %d *******\n",j++);
                       		num_actions=action_planner(params.robot_x, params.robot_y,params.robot_theta,&plan);
				flg_once=0;
				for(k=1; k<= num_actions;k++){
		                        printf("PLAN  to be executed: %d %s\n",k,plan.action_plan[k]);

					msg.stamp = ros::Time::now();	 		// Save current time in the stamp of 'msg'
					msg.data = k;					// Save the the 'count' value in the data of 'msg'
					ss=plan.action_plan[k];	
					//ss << "action planner " << k;
					msg.action=ss;
					ROS_INFO("send msg = %d", msg.stamp.sec);	// Print the 'stamp.sec' message
					ROS_INFO("send msg = %d", msg.stamp.nsec);	// Print the 'stamp.nsec' message
					ROS_INFO("send msg = %d", msg.data);		// Print the 'data' message
					//printf("send msg action %s\n",msg.action.c_str());     // Shows the 'action' message

					ROS_INFO("send msg action = %s", msg.action.c_str());		// Print the 'data' message
					//sleep(1.0);
					//action_planner_msg.publish(msg);	 	// Publishes 'msg' message
					flg_msg = 0;

					// quitar esto después
					sscanf(plan.action_plan[k],"%s %s %d %s",ROS_System,string1,&j,exe_action);
					printf("exe_action %s\n",exe_action);
					if(strcmp(exe_action,"goto")==0){
						action_planner_msg.publish(msg);	 	// Publishes 'msg' message
						flg_msg = 0;
						//sleep(1.0);
					}
					else if(strcmp(exe_action,"mv")==0){
						action_planner_msg.publish(msg);	 	// Publishes 'msg' message
                                                flg_msg = 0;
                                        }
					else if(strcmp(exe_action,"go")==0){
						action_planner_msg.publish(msg);	 	// Publishes 'msg' message
                                                flg_msg = 0;
                                        }
 					else if(strcmp(exe_action,"grab")==0){
						sscanf(plan.action_plan[k],"%s %s %d %s %s",ROS_System,string1,&j,exe_action,object);
						send_grab_drop(exe_action,object,answer);
						printf("\nAnswer MANIPULATOR %s\n",answer);
						flg_msg = 1;
					}	
					else if(strcmp(exe_action,"drop")==0){
                                                sscanf(plan.action_plan[k],"%s %s %d %s %s",ROS_System,string1,&j,exe_action,object);
                                                send_grab_drop(exe_action,object,answer);
                                                printf("\nAnswer MANIPULATOR %s\n",answer);
						ROS_INFO("send msg = %d", msg.stamp.sec);       // Print the 'stamp.sec' message
                                        	ROS_INFO("send msg = %d", msg.stamp.nsec);      // Print the 'stamp.nsec' message
                                        	ROS_INFO("send msg = %d", msg.data);            // Print the 'data' message
						sprintf(string2,"%s %s %d %s",ROS_System,string1,j,answer);
						msg.action=string2;
                                        	ROS_INFO("send DROP position = %s", msg.action.c_str());           // Print the 'data' message
						//sleep(1.0);
                                        	action_planner_msg.publish(msg);                // Publishes to motion planner to update the dropped position
                                                flg_msg = 1;
                                        }
					else flg_msg = 1;

					printf("waiting for an answer flg_message %d\n", flg_msg);
					while(flg_msg == 0){
						ros::spinOnce();
						sleep(0.01);
					}
					// It notifies to the action planner in CLIPS that action plan number was executed	
					send_clips(k);
                		}
			}

                	break;

		default:

                    //printf(" ******* SELECTION NO DEFINED %d *******\n",j++);
    		    

                    break;
    
	}


     }

     ros::spinOnce();

   }


}
